//SCHERM
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

//KEYPAD
#include <Keypad.h>

#define Password_Length 8
char Data[Password_Length];
char Master[Password_Length] = "186AB56";

int COUNTDOWN = 30;

byte data_count = 0;

char customKey;

const byte ROWS = 4;
const byte COLS = 4;

char hexaKeys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};

byte rowPins[ROWS] = {9, 8, 7, 6};
byte colPins[COLS] = {5, 4, 3, 2};

Keypad customKeypad = Keypad(makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS);

//SCHERM
LiquidCrystal_I2C lcd(0x27, 16, 2);

//LED EN BUZZER
int led_Pin = 12;
int led_Pin_2 = 11;
int KnopAan = false; 

int Delay_Tijd_Lampje = 1000;
int Delay_Tijd_Buzzer = 1000;
int Delay_Buzzer = Delay_Tijd_Buzzer / 30;
int Delay_Bonus = 0;

long tijd_Lampje_Aan = millis();
long tijd_Lampje_Uit = millis();
long tijd_Buzzer_Aan = millis();
long tijd_Buzzer_Uit = millis();

//intervals voor wanneer de taak gebeurd
long interval_Lampje_Aan = 2000;
long interval_Lampje_Uit = interval_Lampje_Aan + Delay_Tijd_Lampje;
long interval_Buzzer_Aan = 3000;
long interval_Buzzer_Uit = interval_Buzzer_Aan + Delay_Tijd_Buzzer;

//POTMETER
bool Signaal_Aan = false;
bool executed = false;

  void setup(){
    Serial.begin(9600);

    pinMode(led_Pin,OUTPUT);
    pinMode(2,INPUT);

    //SCHERM
    lcd.backlight();
    lcd.init();
  }

    void loop(){   
      //KEYPAD
      lcd.setCursor(0, 0);
      lcd.print("Enter Password:");

      customKey = customKeypad.getKey();

      if(KnopAan == true && Signaal_Aan == true){

      if (customKey){
        Data[data_count] = customKey;
        lcd.setCursor(data_count, 1);
        lcd.print(Data[data_count]);
        data_count++;
      }

      if(data_count == Password_Length - 1){
        lcd.clear();

        if (!strcmp(Data, Master)) {
          //Password is correct
          if(COUNTDOWN > 0) {
            TIMER();
            }
            else{
              lcd.clear();
              clearData();
            }
        }
        else {
          lcd.print("Incorrect");
          delay(1000);
          //Alles verwijderen
          lcd.clear();
          clearData();
        }
      }

      }

      //LED EN BUZZER
      long startTime = millis();
      
      //POTMETER
      int sensorValue = analogRead(A0);

      Serial.println(sensorValue);

      //Serial.ln(sensorValue);

      //delay(1);

      if(sensorValue > 400 && sensorValue < 700){ 
        Signaal_Aan = true;
      }
      else{
        Signaal_Aan = false;
      }

      if(!executed && Signaal_Aan == true){
        Signaal(startTime);
        executed = true;
      }

      //LED EN BUZZER
      if(digitalRead(10) == HIGH) {
        KnopAan = true;
        
        tijd_Lampje_Aan = startTime;
        tijd_Lampje_Uit = startTime;
        tijd_Buzzer_Aan = startTime;
        tijd_Buzzer_Uit = startTime;
      }

      if(startTime - tijd_Lampje_Aan > interval_Lampje_Aan && KnopAan == true && Signaal_Aan == true){
          Led1Aan();
          tijd_Lampje_Aan = startTime;
      }

      if(startTime - tijd_Lampje_Uit > interval_Lampje_Uit && KnopAan == true && Signaal_Aan == true){
          Led1Uit();
          tijd_Lampje_Uit = startTime - (1 * Delay_Tijd_Lampje);
      }

    }    

      void Led1Aan(){
          digitalWrite(led_Pin_2,HIGH);
      }

      void Led1Uit(){
          digitalWrite(led_Pin_2,LOW);
      }

      void BuzzerAan(){
          tone(led_Pin,(460 - (0.5 * COUNTDOWN)));
      }

      void BuzzerUit(){
          noTone(led_Pin);
      }

      void Signaal(int X){
        tijd_Lampje_Aan = X;
        tijd_Lampje_Uit = X;
        tijd_Buzzer_Aan = X;
        tijd_Buzzer_Uit = X;
      }

      void clearData() {
        while (data_count != 0) {
          Data[data_count--] = 0;
        }
        return;
      }

      void TIMER(){
          lcd.print("Correct");
          delay(1000);
          lcd.clear(); 

        for(int i = 30; i>0; i--){
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Countdown:");
          lcd.setCursor(0, 1);
          lcd.print(i); 
          BuzzerAan();
          Led1Aan();
          delay(Delay_Tijd_Buzzer);
          BuzzerUit();
          Led1Uit();
          delay(Delay_Bonus);

          COUNTDOWN = COUNTDOWN - 1; 
          Delay_Tijd_Buzzer = Delay_Tijd_Buzzer - Delay_Buzzer;
          Delay_Bonus = Delay_Bonus + Delay_Buzzer;

          if(COUNTDOWN == 0){
            lcd.clear();
            lcd.setCursor(0, 0);
            lcd.print("BOOM");
            delay(10000);
          }
        }  
      }
